#ifndef KEYBOARDCONTROLER_HPP
#define KEYBOARDCONTROLER_HPP

#include "Controler.hpp"
#include "Game/Boards/ChessBoard.hpp"

class KeyboardControler : public Controler<ChessBoard>
{
private:

public:
    ~KeyboardControler() {}

    Move<ChessBoard::Coords> getMove();

    void notify(const Move<ChessBoard::Coords> & move) { (void)move; }
};

/*! \class KeyboardControler KeyboardControler.hpp Controlers/KeyboardControler.hpp
 *  \brief Simpler controler implementation to get keyboard inputs
 *
 *  This controler just get and parse the input from the standard input of the console
 *  The parser is able to strip out any space from the input
 *  The \c notify() is not used
 */

#endif
