#include "QtControler.hpp"

void QtControler::moveReceiver(Move<ChessBoard::Coords> m)
{
    if ( m.color() == this->m_colorControlled )
    {
        m_mutex.lock();
        m_moves.push_back(m);
        m_semaphore.release(1);
        m_mutex.unlock();
    }
}

Move<ChessBoard::Coords> QtControler::getMove()
{
    Move<ChessBoard::Coords> m;

    m_semaphore.acquire(1);
    m_mutex.lock();
    m = m_moves.front();
    m_moves.erase(m_moves.begin());
    m_mutex.unlock();

    return m;
}
