#include "History.hpp"

#include <cassert>

void History<Move<ChessBoard::Coords> >::add(const Move<ChessBoard::Coords>& data)
{
    if ( data.color() == 0 )
    {
        m_tmpData.first = data;
    }
    else if ( data.color() == 1 )
    {
        m_tmpData.second = data;
        m_history.push_back(m_tmpData);
    }
}

const Move<ChessBoard::Coords>& History<Move<ChessBoard::Coords> >::get(size_t i, int color)const
{
    assert(i < size());

    const TurnData& tmpData = m_history[i];
    if ( color == 0 )
    {
        return tmpData.first;
    }
    return tmpData.second;
}

const History<Move<ChessBoard::Coords> >::TurnData& History<Move<ChessBoard::Coords> >::get(size_t i)const
{
    assert(i < size());

    return m_history[i];
}
