#include "HistoryLoader.hpp"

#include "Utils/MoveParser.hpp"

#include <fstream>
#include <iostream>
#include <cassert>

History<Move<ChessBoard::Coords> > HistoryLoader<Move<ChessBoard::Coords> >::load(const std::string& fileName, bool& error)
{
    History<Move<ChessBoard::Coords> > history;
    std::ifstream file(fileName.c_str());
    if ( file.is_open() )
    {
        do
        {
            std::string move1;
            file >> move1;
            if ( file.eof() )
            {
                break;
            }

            std::string garbage;
            file >> garbage;
            std::string move2;
            file >> move2;

            Move<ChessBoard::Coords> m1 = MoveParser::parse(move1,0);
            Move<ChessBoard::Coords> m2 = MoveParser::parse(move2,1);

            if ( !m1.isLegal() || !m2.isLegal() )
            {
                std::cout << "Invalid move in history" << std::endl;
                error = true;
                return history;
            }

            history.add(m1);
            history.add(m2);
        }while(!file.eof());
    }
    else
    {
        error = true;
        return history;
    }

    file.close();
    return history;
}
