#include "HistorySaver.hpp"

#include <fstream>
#include <cassert>

std::ostream& operator<< (std::ostream& out, const Move<ChessBoard::Coords>& move)
{
    out << static_cast<char>(move.start().column + 'a');
    out << static_cast<char>(move.start().line + '1');
    out << static_cast<char>(move.dest().column + 'a');
    out << static_cast<char>(move.dest().line + '1');
    if ( move.hasProperty("promotion") )
    {
        out << static_cast<char>(move.getProperty("promotion"));
    }
    else if ( move.hasProperty("promotionID") )
    {
        assert(false);
    }

    return out;
}

bool HistorySaver<Move<ChessBoard::Coords> >::save(const std::string& fileName, const History<Move<ChessBoard::Coords> >& data)
{
    std::ofstream file(fileName.c_str());
    if ( file.is_open() )
    {
        size_t nbElem = data.size();
        for ( size_t i = 0 ; i < nbElem ; i++ )
        {
            std::pair<Move<ChessBoard::Coords>,Move<ChessBoard::Coords> > tdata = data.get(i);
            file << tdata.first << " - " << tdata.second << std::endl;
        }
    }
    else
    {
        return false;
    }

    file.close();

    return true;
}
