#include "Piece.hpp"

Piece::Piece(int owner, int type)
    :m_valid(true),m_color(owner),m_type(type)
{
}

void Piece::setProperty(const std::string& name, int value)
{
    // Can overwrite previous value
    m_properties[name] = value;
}

int Piece::getProperty(const std::string& name)const
{
    const PropertyMap::const_iterator itProp = m_properties.find(name);
    if ( itProp != m_properties.end() )
    {
        return itProp->second;
    }

    // Like an invalid value (the user should check it with hasProperty()
    return -1;
}

bool Piece::hasProperty(const std::string& name)const
{
    const PropertyMap::const_iterator itProp = m_properties.find(name);
    if ( itProp != m_properties.end() )
    {
        return true;
    }

    return false;
}
