#ifndef DAMERULES_HPP
#define DAMERULES_HPP

#include "Rules2D.hpp"

#include "Game/Boards/DameBoard.hpp"

class DameRules : public Rules<DameBoard>,  public Rules2D
{
private:

public:
    static const unsigned int NB_PLAYERS = 2;

    void init(DameBoard& cb);

    bool check(const DameBoard& cb, Move<ChessBoard::Coords>& move)const;

    bool isCheck(const DameBoard& cb, const int color)const;
    bool checkVictory(const DameBoard& cb, const int color)const;

    bool checkDraw(const History<Move<DameBoard::Coords> >& history)const;
    void move(const DameBoard& cb, const Move<DameBoard::Coords>& move);
};

/*! \class DameBoard DameBoard.hpp Game/Rules/DameBoard.hpp
 *  \brief Dame game rules implementation
 *
 *  The Dame rules are just with diagonals and jump other.
 */

#endif
