#include "Qt2DPiece.hpp"

#include <QDebug>

Qt2DPiece::Qt2DPiece(const QString& fileName,int color,QGraphicsItem* parent)
    :QGraphicsSvgItem(fileName,parent),m_color(color),m_rightButton(false)
{
    setAcceptedMouseButtons(Qt::LeftButton | Qt::RightButton);
    setFlag(QGraphicsItem::ItemIsMovable);
    setFlag(QGraphicsItem::ItemIgnoresTransformations);
}

Qt2DPiece::~Qt2DPiece()
{

}

void Qt2DPiece::mousePressEvent(QGraphicsSceneMouseEvent *event)
{
    if ( (event->buttons() & Qt::LeftButton) == Qt::LeftButton )
    {
        m_initialPos = event->scenePos();
        m_initialPiecePos = this->pos();
        m_offsetPos = event->scenePos() - this->pos();
    }
    else if ( (event->buttons() & Qt::RightButton) == Qt::RightButton )
    {
        m_rightButton =true;
        emit requestHelper(event->scenePos(),m_color);
    }
}

void Qt2DPiece::mouseMoveEvent(QGraphicsSceneMouseEvent *event)
{
    if ( (event->buttons() & Qt::LeftButton) == Qt::LeftButton )
    {
        setPos(event->scenePos() - m_offsetPos);
    }

}

void Qt2DPiece::mouseReleaseEvent(QGraphicsSceneMouseEvent *event)
{
    if ( m_rightButton )
    {
        m_rightButton =false;
        emit stopHelper();
    }
    else
    {
        if ( (this->flags() & QGraphicsItem::ItemIsMovable) == QGraphicsItem::ItemIsMovable )
        {
            emit pieceMoved(m_initialPos,event->scenePos(),m_color);
            event->accept();
        }
    }
}

void Qt2DPiece::reset()
{
    this->setPos(m_initialPiecePos);
}
