#ifndef RENDERER2D_HPP
#define RENDERER2D_HPP

#include "Renderer.hpp"

template <typename Board2DType>
class Renderer2D : public Renderer<Board2DType>
{
    typedef typename Board2DType::Coords Coords;

private:

public:

    /*! draw call to display the pieces on 2D board
     */
    virtual void displayBoard()
    {
        for ( int x = 0 ; x < Renderer<Board2DType>::m_pBoard->getDimensionLength(0) ; x++ )
        {
            for ( int y = 0 ; y < Renderer<Board2DType>::m_pBoard->getDimensionLength(1) ; y++ )
            {
                this->displayPiece(Coords(x,y));
            }
        }
    }
};

/*! \class Renderer2D Renderer2D.hpp Renderers/Renderer2D.hpp
 *  \brief Base class for 2D board renderers
 *
 *  This base gives an implementation of displayBoard() for 2D boards which will call
 *  the displayPiece() function for all cases.
 */

#endif
