#ifndef PROMOTIONDIALOG_HPP
#define PROMOTIONDIALOG_HPP

#include <QDialog>

namespace Ui {
    class PromotionDialog;
}

class PromotionDialog : public QDialog
{
private:

    Ui::PromotionDialog* m_pUI;     /*!< */

public:
    /*!
     *  \param color the color of the piece to display (0 : white / 1 : black)
     *  \param parent the parent for this UI
     */
    explicit PromotionDialog(int color, QWidget* parent);

    /*!
     */
    ~PromotionDialog();

    /*! Get the choice of the user of the piece
     *  \return return the char corresponding to the pice selected
     */
    char getChoice()const;
};

/*! \class PromotionDialog PromotionDialog.hpp UI/PromotionDialog.hpp
 *  \brief Interface to select the piece to get when promotion of a pawn
 *
 *  The interface displays four radio button to select which piece has to be used
 *  for the promotion of a pawn. The choice can be getted as the letter representating the piece
 *  with the function getChoice().
 */

#endif
